clear all
clc
F = @(x) 1/(1+x^2);   %% function handle for the given function
for i=1:9
    x(i) = 2.5*(i-1) - 10;  %% calculating xi's
    f(i) = F(x(i));   %% calculating fi's
end

%%% degree 8 polynomail
n = 8;   %% degree of polynomial
%%% defining a matrix A such that
for i=1:n+1
    A(:,i) = x'.^(n+1-i);  
end
coeff_p8 = inv(A) * f';   %%% finding coefficients an,a_(n-1),..,a_0
p8_x = [-10:0.2:10];   %% creating column vector of xi's 
for i=1:length(p8_x)
    p8(i)=0;
    for j=1:9
        p8(i) = p8(i) + coeff_p8(j)*p8_x(i)^(9-j);  %%% calculating values at corresponding xi's
    end
end

%% degree 4 least square fitting polynomial
p = polyfit(x,f,4);
p4 = polyval(p,p8_x);

%% cubic spline
sp = spline(x,f,[-10:0.5:10]); 

figure(1)
scatter(x,f)
xlabel("--x-->")
ylabel("--F-->")
hold on
fplot(F,'y')

hold on
plot((p8_x),p8,'b')

hold on
plot(p8_x,p4,'g')

hold on
plot([-10:0.5:10],sp,'k')


%%%%%   2.2   %%%%%%%i
% scattered points and function are plotted as given.
% 
% Curve of Degree 8 polynomial is shown in blue color,
% It seems like it is overfitting the curve of the function F. 
% 
% Curve of degree 4(green color) is having the maximum deviation of values with respect to F.
% Higher degree curve has a better approximation as it is clear from the figure also.
% Polynomail Interpolation always  gives a unique polynomial.
% 
% Moreover cubic spline is best fitted  graph as shown in figure,
% Cubic spline uses knot vectors to draw the spline and the spline always
% pass through the end point.
% 
% 


